#!/bin/sh

case "$1" in

start)

  modprobe fotg210-udc
  modprobe usb_f_fs
  modprobe usb_f_hid
  modprobe usb_f_mass_storage
  modprobe usb_f_acm.ko
  modprobe usb_f_obex.ko
  modprobe usb_f_serial.ko

  #mount -t configfs none /sys/kernel/config/;
  #mkdir -p /sys/kernel/config/usb_gadget/g1;
  #cd /sys/kernel/config/usb_gadget/g1;

  mount -t configfs none /config/;
  mkdir -p /config/usb_gadget/g1;
  cd /config/usb_gadget/g1;

  echo 0x1d6b > idVendor # Linux Foundation
  echo 0x0104 > idProduct # Multifunction Composite Gadget
  echo 0x0100 > bcdDevice # v1.0.0
  echo 0x0200 > bcdUSB # USB2
  mkdir -p strings/0x409
  echo "SN-0123456789" > strings/0x409/serialnumber
  echo "RSupport" > strings/0x409/manufacturer
  echo "RVBOX2" > strings/0x409/product

  N="usb0"
  mkdir -p functions/hid.$N
  echo 1 > functions/hid.usb0/protocol
  echo 1 > functions/hid.usb0/subclass
  echo 8 > functions/hid.usb0/report_length
  #echo -ne \\x05\\x01\\x09\\x06\\xa1\\x01\\x05\\x07\\x19\\xe0\\x29\\xe7\\x15\\x00\\x25\\x01\\x75\\x01\\x95\\x08\\x81\\x02\\x95\\x01\\x75\\x08\\x81\\x03\\x95\\x05\\x75\\x01\\x05\\x08\\x19\\x01\\x29\\x05\\x91\\x02\\x95\\x01\\x75\\x03\\x91\\x03\\x95\\x06\\x75\\x08\\x15\\x00\\x25\\x65\\x05\\x07\\x19\\x00\\x29\\x65\\x81\\x00\\xc0 > functions/hid.usb0/report_desc
  echo -ne \\x05\\x01\\x09\\x06\\xa1\\x01\\x05\\x07\\x19\\xe0\\x29\\xe7\\x15\\x00\\x25\\x01\\x75\\x01\\x95\\x08\\x81\\x02\\x95\\x01\\x75\\x08\\x81\\x03\\x95\\x05\\x75\\x01\\x05\\x08\\x19\\x01\\x29\\x05\\x91\\x02\\x95\\x01\\x75\\x03\\x91\\x03\\x95\\x06\\x75\\x08\\x15\\x00\\x25\\x65\\x05\\x07\\x19\\x00\\x29\\xff\\x81\\x00\\xc0 > functions/hid.usb0/report_desc

  N="usb1"
  mkdir -p functions/hid.$N
  echo 1 > functions/hid.usb1/protocol
  echo 1 > functions/hid.usb1/subclass
  echo 8 > functions/hid.usb1/report_length
  # Only Absolute
  echo -ne \\x05\\x01\\x09\\x02\\xa1\\x01\\x09\\x01\\xa1\\x00\\x85\\x02\\x05\\x09\\x19\\x01\\x29\\x03\\x15\\x00\\x25\\x01\\x95\\x03\\x75\\x01\\x81\\x02\\x95\\x01\\x75\\x05\\x81\\x03\\x05\\x01\\x09\\x30\\x09\\x31\\x15\\x00\\x26\\xff\\x7f\\x75\\x10\\x95\\x02\\x81\\x02\\x09\\x38\\x15\\x81\\x25\\x7f\\x75\\x08\\x95\\x01\\x81\\x06\\xc0\\xc0 >  functions/hid.usb1/report_desc

  N="usb2"
  mkdir -p functions/hid.$N
  echo 1 > functions/hid.$N/protocol
  echo 1 > functions/hid.$N/subclass
  echo 8 > functions/hid.$N/report_length
  # Include wheel
  echo -ne \\x05\\x01\\x09\\x02\\xa1\\x01\\x09\\x01\\xa1\\x00\\x85\\x03\\x05\\x09\\x19\\x01\\x29\\x03\\x15\\x00\\x25\\x01\\x95\\x03\\x75\\x01\\x81\\x02\\x95\\x01\\x75\\x05\\x81\\x03\\x05\\x01\\x09\\x30\\x09\\x31\\x15\\x81\\x25\\x7f\\x75\\x08\\x95\\x02\\x81\\x06\\xa1\\x02\\x09\\x38\\x15\\x81\\x25\\x7f\\x75\\x08\\x95\\x01\\x81\\x06\\xc0\\xc0\\xc0 > functions/hid.usb2/report_desc

  mkdir -p functions/acm.usb0

  mkdir functions/mass_storage.usb0
  #echo /dev/mmcblk2p5 > functions/mass_storage.usb0/lun.0/file
  echo /mnt/emmc1/mass_storage.img > functions/mass_storage.usb0/lun.0/file

  C=1
  mkdir -p configs/c.$C/strings/0x409
  echo "Config $C: ECM network" > configs/c.$C/strings/0x409/configuration
  echo 250 > configs/c.$C/MaxPower
  #ln -s functions/hid.usb0 configs/c.$C/
  #ln -s functions/hid.usb1 configs/c.$C/
  #ln -s functions/hid.usb2 configs/c.$C/
  ln -s functions/acm.usb0 configs/c.$C/

  #ln -s functions/mass_storage.usb0 configs/c.1

  echo "f0600000.nvt_usb2dev" > UDC
  ;;

stop)
	echo "Stoping the USB gadget"
	cd /config/usb_gadget/g1
	if [ $? -ne 0 ]; then
		echo "Error: no configfs gadget found"
		exit 1;
	fi
	echo "" > UDC
	;;

bind)
  # Bind시 필요한 모든 가젯을 등록한다.
	echo "bind USB Device Controller"
	cd /config/usb_gadget/g1/
  ln -s functions/acm.usb0 configs/c.$C/
  #ln -s functions/hid.usb0 configs/c.$C/
  #ln -s functions/acm.usb0 configs/c.$C/
  #ln -s functions/mass_storage.usb0 configs/c.1
	ls /sys/class/udc > UDC
	echo "OK bind"
	;;

unbind)
  echo "Unbinding USB Device Controller"
	cd /config/usb_gadget/g1
  rm -rf configs/c.1/acm.usb0
  rm -rf configs/c.1/hid.usb0
  #rm -rf configs/c.1/hid.usb1
  #rm -rf configs/c.1/hid.usb2
  rm -rf configs/c.1/mass_storage.usb0
  echo "" > UDC
  echo "OK unbind"
	;;
*)
	echo "Usage : $0 {start|stop|bind|unbind}"

esac
